#ifndef MAIN_PROGRAM_H
#define MAIN_PROGRAM_H

#include "virtpoint.h"
class CMainWin
{
protected:
	typedef struct OBJ_ITEM
	{
		CVirtPoint* pObj;
		OBJ_ITEM* pNext;
	}
	OBJ_ITEM;

	//seznam objektu
	OBJ_ITEM* m_pList;
	//pocet objektu v seznamu
	int m_nItems;

	//instance aplikace
	HINSTANCE m_hInstance;
	//okno
	HWND m_hWnd;

public:
	CMainWin()
	{
		m_pList = NULL;
	}

	~CMainWin()
	{
		while (m_pList != NULL)
		{
			OBJ_ITEM* pNext = m_pList->pNext;
			delete m_pList->pObj;
			delete m_pList;
			m_pList = pNext;
		}
	}

	bool InitInstance(HINSTANCE hInstance);
	void ExitInstance();
	int Run();

protected:
	void AddItem(CVirtPoint* pPoint);	
	void OnAddPoint();
	void OnAddCircle();
	void OnAddSquare();
	void OnTimer();
	void OnDraw(HDC hdc);

	LRESULT CALLBACK OnWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
private:
	static LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
};

extern CMainWin theMainWnd;

#endif //MAIN_PROGRAM_H